<?php include("includes/loader.php"); ?>

<?php include("includes/logoutHandler.php"); ?>

<!DOCTYPE html>
<html>

<head>
	<head>
	<?php 
		$pageTitle = 'Chat';
		include_once('tpl/head.php');
	?>
</head>

<body>
	
	<?php include_once('tpl/nav.php'); ?>
	<div class="container">
		<ul class="breadcrumb p-2">
			<li class="breadcrumb-item"><a href="dashboard.php">Dashboard</a></li>
			<li class="breadcrumb-item active" aria-current="page">Chat</li>
		</ul>
	</div>
    
    <div class="container">
    
	<!-- BOX -->
    <div class="box" id="chat-box">
		
		<?php
			$current_session_time = $chat->get_session_time($chat->serverID);
			if($current_session_time == true)
			{
				$session_time = '<span class="session_time">Last seen '.$current_session_time.'</span>';
			} else {
				$session_time = '<span class="session_time">Online</span>';	
			}
		?>
			
    	<div class="header">
			<div class="profile">
				<div class="float-start">
					<img src="images/avatars/user<?php echo $chat->serverID; ?>.png" class="rounded-circle" width="32" height="32">
				</div>
				<div class="float-start">
					<h4><?php echo $chat->server; ?></h4>
					<?php echo $session_time; ?>
				</div>
				<div class="clear"></div>
			</div>
        </div>
        
        <div class="content">
            
			<!-- jChat -->
            <ul class="messages-layout">
                <li class="messages"></li>
            </ul>
            <!-- Enter message field -->
            <span id="sample"></span>
            <div class="message-entry">
                <input type="text" id="text-input-field" class="input-sm" name="message-entry" /> 
                <div class="send-group">
                    <a href="javascript:void(0);" data-option="emotions" class="attachEmotions"></a>
                    <input type="submit" name="send-message" id="sendMessage" class="btn btn-primary" value="Send" />
                </div>
            </div>
            <!-- // jChat -->
                     
        </div>
        
    </div>
    <!-- // END BOX -->
     
    </div>
    <?php include_once('tpl/scripts.php'); ?>
	<script>
   		$().Chat();
   </script>
   <script type="module">
	import { EmojiButton } from './js/@joeattardi/emoji-button/dist/index.js';

	// Load the Twitter Emoji Styles
	const picker = new EmojiButton({style: 'twemoji', position: 'bottom-start'});
	const emojibutton = document.querySelector('.attachEmotions');

	picker.on('emoji', selection => {
	  console.log(selection);
	  let url = selection.url;
	  let testRE = url.match("svg/(.*).svg");
	  let eCode = testRE[1];
	  let current_value = $("input#text-input-field").val();
	  let emoji = ':'+eCode+':';
	  $("input#text-input-field").val(current_value+emoji);
	});

	emojibutton.addEventListener('click', () => picker.togglePicker(emojibutton));
	</script>
</body> 
</html>