/*
 *	jQuery Chat Plugin
 *	Ajax Chat plugin for jquery
 *	Version 1.5, April, 2016
 *		Version 1.8, September, 2021
 *	Released Under Envato Regular and Extended Licenses by Paulo Regina
 *  www.pauloreg.com
 */
 
function getParameterByName(name) {
    name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
    var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
        results = regex.exec(location.search);
    return results == null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}

(function($) {
 
    $.fn.extend({
        
		// Chat Plugin 
        Chat: function(options) 
		{
 			
			// Default Configurations
			var chat = {}
			
            var defaults = {
				ajaxMessage: 'includes/ajax_messages.php',
				ajaxDelete: 'includes/ajax_del_messages.php',
				ajaxSendMessage: 'includes/ajax_send.php',
				ajaxUpdate: 'includes/ajax_update.php',
				ajaxLastSeen: 'includes/ajax_last_seen.php',
				chat: '',
				waitRefresh: 800,
				chatRefresh: 4000,
				emoticonsModal: '#emoticons',
				
				realtime: true
            }
			
			var options =  $.extend(defaults, options);
			
			var opt = options;
			
			chat.renderChat = function()
							{

								$(opt.chat).html(chat.messages());

								$("ul.messages-layout").on('click', 'span.delete', function() 
							 	{	
									var message_id = $(this).closest('.message-area').parent().attr("id");
									
									var construct = {messageID: message_id};
									
									$.post(opt.ajaxDelete, construct, function(response){});
									
									var client_or_server = $(this).closest('.message-area').parent().attr("class");
									var client_or_server_id = $(this).closest('.message-area').parent().attr("id");
									
									$("li."+client_or_server+'#'+client_or_server_id).remove();
								});
								
								// Handle Emoticons
								$(document).on('click', '[data-option="emotions"]', function(e) 
							 	{	
									
	
								});
																
							}
			
			chat.messages = function() 
							  {
								var construct = {clientID: 'set'}
								
								$.post(opt.ajaxMessage, construct, function(response) 
								{
									if(response)
									{
										$("ul.messages-layout").html(response);
										
										toScroll = $("ul.messages-layout");
										$("ul.messages-layout").animate({ scrollTop: toScroll[0].scrollHeight }, 'fast');
									} 
								});	
																
							  }
			
			chat.sendOnPress = function()
								{
									$('#text-input-field').keypress(function(e)
									{
										if(e.which == 13)
										{
											chat.sendMessage();	
										}
									});
								}
			
			chat.sendOnClick = function()
								{
									$("#sendMessage").on('click', function(e) 
							 		{	
										chat.sendMessage();
									});
								}
			
			chat.inputHandler = function()
								{
									chat.sendOnPress();
									chat.sendOnClick();
								}
			
			chat.update = function()
						  {
							var construct = {update: 'true', id: getParameterByName('id')}
							$.post(opt.ajaxUpdate, construct, function(response)
							{   
								if(response.length !== 0)
								{
									response = $.parseJSON(response);
								
									last_message = parseInt( $('ul.messages-layout').find('li:last-child').attr('id') ) || 0; 
									
									last_message_server = response.last_message;
									
									if(last_message_server > last_message)
									{
										$("ul.messages-layout").append(response.message);
										
										$(document).prop('title', 'jChat ' + response.new_messages);
										
										toScroll = $("ul.messages-layout");
										$("ul.messages-layout").animate({ scrollTop: toScroll[0].scrollHeight }, 'fast');
									}
								}
							});
						  }
			
			chat.sendMessage = function()
							 {
								var message_entry = $('#text-input-field').val();
								var construct = { message: message_entry, id: getParameterByName('id') };
								
								$.post(opt.ajaxSendMessage, construct, function(response)
								{
									setTimeout(function() {
										$("ul.messages-layout").append(response);
										
										toScroll = $("ul.messages-layout");
										$("ul.messages-layout").animate({ scrollTop: toScroll[0].scrollHeight }, 'fast');
									
									}, opt.waitRefresh);
																		
									$('#text-input-field').val('');
								});
																
							 }
			
			chat.lastSeen = function()
							{
								$(window).bind("beforeunload", function(){
									$.post(opt.ajaxLastSeen, 'offline=true', function(response){}); 	
								}); 
								
								$(window).focus(function() {
									$.post(opt.ajaxLastSeen, 'offline=false', function(response){}); 
								});
							}
								
			chat.polling = function() 
						{
							if(opt.realtime === true)
							{
								chat.interval = setInterval(function() {
								  chat.update();
								}, opt.chatRefresh);
							}
						}
			
			chat.stopPolling = function()
							{
								clearInterval(chat.interval);
								chat.interval = 0;
							}
				
			chat.renderChat();
			chat.inputHandler();
			chat.polling();
			chat.lastSeen();

        } // end chat
		
    }); // end extend
     
})(jQuery);